diff -uNr ntop-3.3.8/install-sh ntop-3.3.9/install-sh
--- ntop-3.3.8/install-sh	2008-10-02 12:54:15.000000000 +0200
+++ ntop-3.3.9/install-sh	2008-12-03 23:00:22.000000000 +0100
@@ -1,7 +1,7 @@
 #!/bin/sh
 # install - install a program, script, or datafile
 
-scriptversion=2006-12-25.00
+scriptversion=2006-10-14.15
 
 # This originates from X11R5 (mit/util/scripts/install.sh), which was
 # later released in X11R6 (xc/config/util/install.sh) with the
@@ -48,7 +48,7 @@
 # set DOITPROG to echo to test this script
 
 # Don't use :- since 4.3BSD and earlier shells don't like it.
-doit=${DOITPROG-}
+doit="${DOITPROG-}"
 if test -z "$doit"; then
   doit_exec=exec
 else
@@ -58,49 +58,34 @@
 # Put in absolute file names if you don't have them in your path;
 # or use environment vars.
 
-chgrpprog=${CHGRPPROG-chgrp}
-chmodprog=${CHMODPROG-chmod}
-chownprog=${CHOWNPROG-chown}
-cmpprog=${CMPPROG-cmp}
-cpprog=${CPPROG-cp}
-mkdirprog=${MKDIRPROG-mkdir}
-mvprog=${MVPROG-mv}
-rmprog=${RMPROG-rm}
-stripprog=${STRIPPROG-strip}
-
-posix_glob='?'
-initialize_posix_glob='
-  test "$posix_glob" != "?" || {
-    if (set -f) 2>/dev/null; then
-      posix_glob=
-    else
-      posix_glob=:
-    fi
-  }
-'
+mvprog="${MVPROG-mv}"
+cpprog="${CPPROG-cp}"
+chmodprog="${CHMODPROG-chmod}"
+chownprog="${CHOWNPROG-chown}"
+chgrpprog="${CHGRPPROG-chgrp}"
+stripprog="${STRIPPROG-strip}"
+rmprog="${RMPROG-rm}"
+mkdirprog="${MKDIRPROG-mkdir}"
 
+posix_glob=
 posix_mkdir=
 
 # Desired mode of installed file.
 mode=0755
 
-chgrpcmd=
 chmodcmd=$chmodprog
 chowncmd=
-mvcmd=$mvprog
-rmcmd="$rmprog -f"
+chgrpcmd=
 stripcmd=
-
+rmcmd="$rmprog -f"
+mvcmd="$mvprog"
 src=
 dst=
 dir_arg=
-dst_arg=
-
-copy_on_change=false
+dstarg=
 no_target_directory=
 
-usage="\
-Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
+usage="Usage: $0 [OPTION]... [-T] SRCFILE DSTFILE
    or: $0 [OPTION]... SRCFILES... DIRECTORY
    or: $0 [OPTION]... -t DIRECTORY SRCFILES...
    or: $0 [OPTION]... -d DIRECTORIES...
@@ -110,55 +95,65 @@
 In the 4th, create DIRECTORIES.
 
 Options:
-     --help     display this help and exit.
-     --version  display version info and exit.
-
-  -c            (ignored)
-  -C            install only if different (preserve the last data modification time)
-  -d            create directories instead of installing files.
-  -g GROUP      $chgrpprog installed files to GROUP.
-  -m MODE       $chmodprog installed files to MODE.
-  -o USER       $chownprog installed files to USER.
-  -s            $stripprog installed files.
-  -t DIRECTORY  install into DIRECTORY.
-  -T            report an error if DSTFILE is a directory.
+-c         (ignored)
+-d         create directories instead of installing files.
+-g GROUP   $chgrpprog installed files to GROUP.
+-m MODE    $chmodprog installed files to MODE.
+-o USER    $chownprog installed files to USER.
+-s         $stripprog installed files.
+-t DIRECTORY  install into DIRECTORY.
+-T         report an error if DSTFILE is a directory.
+--help     display this help and exit.
+--version  display version info and exit.
 
 Environment variables override the default commands:
-  CHGRPPROG CHMODPROG CHOWNPROG CMPPROG CPPROG MKDIRPROG MVPROG
-  RMPROG STRIPPROG
+  CHGRPPROG CHMODPROG CHOWNPROG CPPROG MKDIRPROG MVPROG RMPROG STRIPPROG
 "
 
 while test $# -ne 0; do
   case $1 in
-    -c) ;;
-
-    -C) copy_on_change=true;;
+    -c) shift
+        continue;;
 
-    -d) dir_arg=true;;
+    -d) dir_arg=true
+        shift
+        continue;;
 
     -g) chgrpcmd="$chgrpprog $2"
-	shift;;
+        shift
+        shift
+        continue;;
 
     --help) echo "$usage"; exit $?;;
 
     -m) mode=$2
+        shift
+        shift
 	case $mode in
 	  *' '* | *'	'* | *'
 '*	  | *'*'* | *'?'* | *'['*)
 	    echo "$0: invalid mode: $mode" >&2
 	    exit 1;;
 	esac
-	shift;;
+        continue;;
 
     -o) chowncmd="$chownprog $2"
-	shift;;
-
-    -s) stripcmd=$stripprog;;
-
-    -t) dst_arg=$2
-	shift;;
-
-    -T) no_target_directory=true;;
+        shift
+        shift
+        continue;;
+
+    -s) stripcmd=$stripprog
+        shift
+        continue;;
+
+    -t) dstarg=$2
+	shift
+	shift
+	continue;;
+
+    -T) no_target_directory=true
+	shift
+	continue;;
 
     --version) echo "$0 $scriptversion"; exit $?;;
 
@@ -170,22 +165,21 @@
 
     *)  break;;
   esac
-  shift
 done
 
-if test $# -ne 0 && test -z "$dir_arg$dst_arg"; then
+if test $# -ne 0 && test -z "$dir_arg$dstarg"; then
   # When -d is used, all remaining arguments are directories to create.
   # When -t is used, the destination is already specified.
   # Otherwise, the last argument is the destination.  Remove it from $@.
   for arg
   do
-    if test -n "$dst_arg"; then
+    if test -n "$dstarg"; then
       # $@ is not empty: it contains at least $arg.
-      set fnord "$@" "$dst_arg"
+      set fnord "$@" "$dstarg"
       shift # fnord
     fi
     shift # arg
-    dst_arg=$arg
+    dstarg=$arg
   done
 fi
 
@@ -230,7 +224,7 @@
 do
   # Protect names starting with `-'.
   case $src in
-    -*) src=./$src;;
+    -*) src=./$src ;;
   esac
 
   if test -n "$dir_arg"; then
@@ -248,22 +242,22 @@
       exit 1
     fi
 
-    if test -z "$dst_arg"; then
+    if test -z "$dstarg"; then
       echo "$0: no destination specified." >&2
       exit 1
     fi
 
-    dst=$dst_arg
+    dst=$dstarg
     # Protect names starting with `-'.
     case $dst in
-      -*) dst=./$dst;;
+      -*) dst=./$dst ;;
     esac
 
     # If destination is a directory, append the input filename; won't work
     # if double slashes aren't ignored.
     if test -d "$dst"; then
       if test -n "$no_target_directory"; then
-	echo "$0: $dst_arg: Is a directory" >&2
+	echo "$0: $dstarg: Is a directory" >&2
 	exit 1
       fi
       dstdir=$dst
@@ -384,19 +378,26 @@
       # directory the slow way, step by step, checking for races as we go.
 
       case $dstdir in
-	/*) prefix='/';;
-	-*) prefix='./';;
-	*)  prefix='';;
+	/*) prefix=/ ;;
+	-*) prefix=./ ;;
+	*)  prefix= ;;
       esac
 
-      eval "$initialize_posix_glob"
+      case $posix_glob in
+        '')
+	  if (set -f) 2>/dev/null; then
+	    posix_glob=true
+	  else
+	    posix_glob=false
+	  fi ;;
+      esac
 
       oIFS=$IFS
       IFS=/
-      $posix_glob set -f
+      $posix_glob && set -f
       set fnord $dstdir
       shift
-      $posix_glob set +f
+      $posix_glob && set +f
       IFS=$oIFS
 
       prefixes=
@@ -458,54 +459,41 @@
     # ignore errors from any of these, just make sure not to ignore
     # errors from the above "$doit $cpprog $src $dsttmp" command.
     #
-    { test -z "$chowncmd" || $doit $chowncmd "$dsttmp"; } &&
-    { test -z "$chgrpcmd" || $doit $chgrpcmd "$dsttmp"; } &&
-    { test -z "$stripcmd" || $doit $stripcmd "$dsttmp"; } &&
-    { test -z "$chmodcmd" || $doit $chmodcmd $mode "$dsttmp"; } &&
-
-    # If -C, don't bother to copy if it wouldn't change the file.
-    if $copy_on_change &&
-       old=`LC_ALL=C ls -dlL "$dst"	2>/dev/null` &&
-       new=`LC_ALL=C ls -dlL "$dsttmp"	2>/dev/null` &&
-
-       eval "$initialize_posix_glob" &&
-       $posix_glob set -f &&
-       set X $old && old=:$2:$4:$5:$6 &&
-       set X $new && new=:$2:$4:$5:$6 &&
-       $posix_glob set +f &&
-
-       test "$old" = "$new" &&
-       $cmpprog "$dst" "$dsttmp" >/dev/null 2>&1
-    then
-      rm -f "$dsttmp"
-    else
-      # Rename the file to the real destination.
-      $doit $mvcmd -f "$dsttmp" "$dst" 2>/dev/null ||
-
-      # The rename failed, perhaps because mv can't rename something else
-      # to itself, or perhaps because mv is so ancient that it does not
-      # support -f.
-      {
-	# Now remove or move aside any old file at destination location.
-	# We try this two ways since rm can't unlink itself on some
-	# systems and the destination file might be busy for other
-	# reasons.  In this case, the final cleanup might fail but the new
-	# file should still install successfully.
-	{
-	  test ! -f "$dst" ||
-	  $doit $rmcmd -f "$dst" 2>/dev/null ||
-	  { $doit $mvcmd -f "$dst" "$rmtmp" 2>/dev/null &&
-	    { $doit $rmcmd -f "$rmtmp" 2>/dev/null; :; }
-	  } ||
-	  { echo "$0: cannot unlink or rename $dst" >&2
-	    (exit 1); exit 1
-	  }
-	} &&
-
-	# Now rename the file to the real destination.
-	$doit $mvcmd "$dsttmp" "$dst"
-      }
-    fi || exit 1
+    { test -z "$chowncmd" || $doit $chowncmd "$dsttmp"; } \
+      && { test -z "$chgrpcmd" || $doit $chgrpcmd "$dsttmp"; } \
+      && { test -z "$stripcmd" || $doit $stripcmd "$dsttmp"; } \
+      && { test -z "$chmodcmd" || $doit $chmodcmd $mode "$dsttmp"; } &&
+
+    # Now rename the file to the real destination.
+    { $doit $mvcmd -f "$dsttmp" "$dst" 2>/dev/null \
+      || {
+	   # The rename failed, perhaps because mv can't rename something else
+	   # to itself, or perhaps because mv is so ancient that it does not
+	   # support -f.
+
+	   # Now remove or move aside any old file at destination location.
+	   # We try this two ways since rm can't unlink itself on some
+	   # systems and the destination file might be busy for other
+	   # reasons.  In this case, the final cleanup might fail but the new
+	   # file should still install successfully.
+	   {
+	     if test -f "$dst"; then
+	       $doit $rmcmd -f "$dst" 2>/dev/null \
+	       || { $doit $mvcmd -f "$dst" "$rmtmp" 2>/dev/null \
+		     && { $doit $rmcmd -f "$rmtmp" 2>/dev/null; :; }; }\
+	       || {
+		 echo "$0: cannot unlink or rename $dst" >&2
+		 (exit 1); exit 1
+	       }
+	     else
+	       :
+	     fi
+	   } &&
+
+	   # Now rename the file to the real destination.
+	   $doit $mvcmd "$dsttmp" "$dst"
+	 }
+    } || exit 1
 
     trap '' 0
   fi
diff -uNr ntop-3.3.8/Makefile.am ntop-3.3.9/Makefile.am
--- ntop-3.3.8/Makefile.am	2008-06-26 10:38:58.000000000 +0200
+++ ntop-3.3.9/Makefile.am	2008-12-03 23:00:22.000000000 +0100
@@ -73,13 +73,12 @@
 ETTER_PASSIVE_DOWNLOAD_FROM = "http://ettercap.cvs.sourceforge.net/ettercap/ettercap_ng/share"
 ETTER_PASSIVE_DOWNLOAD_PARMS = "rev=HEAD"
 
-
-
 NTOPDATA = ntop-cert.pem \
-           p2c.opt.table.gz \
            $(ETTER_PASSIVE) \
            oui.txt.gz \
-           specialMAC.txt.gz
+           specialMAC.txt.gz \
+	   GeoIPASNum.dat \
+	   GeoLiteCity.dat
 
 NTOPHTML = html html/*.js html/*.html  html/*.gif html/*.jpg html/*.ico html/*.png \
            html/*.css html/*.dtd \
@@ -148,7 +147,7 @@
 libntopreport_la_SOURCES = emitter.c       globals-report.c  graph.c \
                            fcReport.c      http.c            perl.c  \
                            report.c        reportUtils.c     ssl.c   \
-                           webInterface.c
+                           webInterface.c  map.c
 
 
 libntopreport_la_DEPENDENCIES = libntop.la
@@ -271,6 +270,8 @@
 
 install: install-recursive
 
+	cd @GEO_DIR@; make install
+
 	@mkdir -p $(DESTDIR)/$(CFG_DBFILE_DIR)
 
 	@echo ""
@@ -285,24 +286,6 @@
 	  fi; \
 	done
 
-	@if ! test -f $(DESTDIR)/$(CFG_CONFIGFILE_DIR)/AS-list.txt.gz; then \
-	  echo ""; \
-	  echo ""; \
-	  echo "------------------------------------------------------------"; \
-	  echo ""; \
-	  echo "NOTE: ntop can show traffic by AS (Autonomous System) Number"; \
-	  echo ""; \
-	  echo "      Because this feature consumes a number of MB of memory,"; \
-	  echo "      the datafile is not installed by default."; \
-	  echo ""; \
-	  echo "      Which, if there is no file - from this or a previous"; \
-	  echo "      install - effectively disables the ASN feature."; \
-	  echo ""; \
-	  echo "      To install the AS data, type:"; \
-	  echo ""; \
-	  echo "# make install-data-as"; \
-	fi
-
 	@if test ".$(CLEANLIST)" != "."; then \
 	  echo ""; \
 	  echo ""; \
@@ -352,16 +335,6 @@
 	fi
 
 
-install-data-as:
-	@$(top_srcdir)/mkinstalldirs $(DESTDIR)/$(CFG_CONFIGFILE_DIR);
-	@for file in AS-list.txt.gz; do \
-          if test -d $$file; then \
-             $(top_srcdir)/mkinstalldirs $(DESTDIR)/$(CFG_CONFIGFILE_DIR)/$$file; \
-           else \
-             cp -p $$file $(DESTDIR)/$(CFG_CONFIGFILE_DIR)/$$file; \
-          fi; \
-        done
-
 install-data-local: ntop.txt ntop.html faq.html
 	@$(top_srcdir)/mkinstalldirs $(DESTDIR)/$(libdir)/plugins;
 	@if ! test -d $(DESTDIR)/$(datadir)/ntop; then \
@@ -466,10 +439,6 @@
 	@echo "New file is:"
 	@ls -l $(ETTER_PASSIVE)
 
-# download the data for and make the p2c.opt.table
-p2ctable:
-	@utils/p2c
-
 # ntop census
 census-fail:
 	@echo "This option is no longer available... thanks for trying"
diff -uNr ntop-3.3.8/map.c ntop-3.3.9/map.c
--- ntop-3.3.8/map.c	1970-01-01 01:00:00.000000000 +0100
+++ ntop-3.3.9/map.c	2008-12-09 12:41:47.000000000 +0100
@@ -0,0 +1,90 @@
+/*
+ *  Copyright (C) 2008 Luca Deri <deri@ntop.org>
+ *
+ *  			    http://www.ntop.org/
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ */
+
+#include "ntop.h"
+#include "globals-report.h"
+
+#define MAX_NUM_MAP_HOSTS 512
+
+const char *map_head = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n<html xmlns=\"http://www.w3.org/1999/xhtml\">\n  <head>\n    <meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\"/>\n    <script src=\"http://maps.google.com/maps?file=api&amp;v=2&amp;key=";
+const char *map_head2 = "\"\n      type=\"text/javascript\"></script>\n    <script type=\"text/javascript\">\n\n    //<![CDATA[\n\n    function load() {\n      if (GBrowserIsCompatible()) {\n\n       function createMarker(point,html) {\n        var marker = new GMarker(point);\n        GEvent.addListener(marker, \"click\", function() {\n          marker.openInfoWindowHtml(html);\n        });\n        return marker;\n      }\n\n        var map = new GMap2(document.getElementById(\"map\"));\n\n        map.addControl(new GLargeMapControl()); map.addControl(new GMapTypeControl());\n        map.addControl(new GMapTypeControl(true));\n        map.setCenter(new GLatLng(43.72, 10.40), 2);\n";
+
+const char *map_tail = "\n      }\n    }\n\n    //]]>\n    </script>\n  </head>\n  <body onload=\"load()\" onunload=\"GUnload()\">\n    <center><div id=\"map\" style=\"width: 800px; height: 600px\"></div></center>\n\n  </body>\n</html>\n";
+
+/* ******************************************** */
+
+static char *googleMapsKey = NULL;
+
+void init_maps() {
+  char value[128];
+
+  if(fetchPrefsValue("google_maps.key", value, sizeof(value)) == -1) {
+    storePrefsValue("google_maps.key", GOOGLE_DEFAULT_MAP_KEY);
+    googleMapsKey = GOOGLE_DEFAULT_MAP_KEY;
+  } else {
+    googleMapsKey = strdup(value);
+  }
+}
+
+void create_host_map() {
+  HostTraffic *el;
+  int num_hosts = 0;
+
+  sendString((char*)map_head);
+  sendString(googleMapsKey);
+  sendString((char*)map_head2);
+  
+  for(el=getFirstHost(myGlobals.actualReportDeviceId);
+      el != NULL; el = getNextHost(myGlobals.actualReportDeviceId, el)) {
+    if(el->geo_ip) {
+      char buf[512];
+      int showSymIp;
+
+      if((el->hostResolvedName[0] != '\0')
+	 && strcmp(el->hostResolvedName, el->hostNumIpAddress)
+	 && (!subnetPseudoLocalHost(el)))
+	showSymIp = 1;
+      else
+	showSymIp = 0;
+
+      safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), 
+		    "map.addOverlay(createMarker(new GLatLng(%.2f, %.2f), '%s%s<A HREF=/%s.html>%s</A><br>%s<br>%s'));\n",
+		    el->geo_ip->latitude, el->geo_ip->longitude,
+		    showSymIp ? el->hostResolvedName : "", 
+		    showSymIp ? "<br>" : "",
+		    el->hostNumIpAddress, el->hostNumIpAddress,
+		    el->geo_ip->city ? el->geo_ip->city : "", 
+		    el->geo_ip->country_name ? el->geo_ip->country_name : "");
+      sendString(buf);
+      num_hosts++;
+      if(num_hosts > MAX_NUM_MAP_HOSTS) break; /* Too many hosts */
+    }
+  }
+
+  sendString((char*)map_tail);
+
+  if(num_hosts > MAX_NUM_MAP_HOSTS)
+    sendString("<p><center><b><font color=red>WARNING:</font></b>You have more hosts to display than the number typically supported by Google maps. Some hosts have not been rendered.</center></p>");
+
+  sendString("<p><center><b><font color=red>NOTE:</font></b>");
+  sendString("make sure you get your key <a href=http://code.google.com/apis/maps/>here</A>"
+	  " for using Google Maps from ntop and register it as \'google_maps.key\' key <A href=/"CONST_EDIT_PREFS"#google_maps.key>here</A>.</center></p>\n"); 
+}
+
diff -uNr ntop-3.3.8/ntop.c ntop-3.3.9/ntop.c
--- ntop-3.3.8/ntop.c	2008-08-05 12:06:31.000000000 +0200
+++ ntop-3.3.9/ntop.c	2008-12-09 12:41:47.000000000 +0100
@@ -448,7 +448,8 @@
 /* **************************************** */
 
 void handleProtocols(void) {
-  char *proto, *buffer=NULL, *strtokState, *bufferCurrent, *bufferWork;
+  char *proto, *buffer=NULL, *strtokState,
+	   *bufferCurrent, *bufferWork, tmpStr[512];
   FILE *fd;
 
   /* myGlobals.protoSpecs is either
@@ -463,25 +464,29 @@
      || (!myGlobals.runningPref.protoSpecs[0]))
     return;
 
-  fd = fopen(myGlobals.runningPref.protoSpecs, "rb");
+   safe_snprintf(__FILE__, __LINE__, tmpStr, sizeof(tmpStr),
+                  "%s", myGlobals.runningPref.protoSpecs);
+
+  revertSlashIfWIN32(tmpStr, 0);
+  fd = fopen(tmpStr, "rb");
 
   if(fd == NULL) {
-    traceEvent(CONST_TRACE_INFO, "PROTO_INIT: Processing protocol list: '%s'", myGlobals.runningPref.protoSpecs);
-    proto = strtok_r(myGlobals.runningPref.protoSpecs, ",", &strtokState);
+    traceEvent(CONST_TRACE_INFO, "PROTO_INIT: Processing protocol list: '%s'", tmpStr);
+    proto = strtok_r(tmpStr, ",", &strtokState);
   } else {
     struct stat buf;
 
-    if(stat(myGlobals.runningPref.protoSpecs, &buf) != 0) {
+    if(stat(tmpStr, &buf) != 0) {
       fclose(fd);
       traceEvent(CONST_TRACE_ERROR, "PROTO_INIT: Unable to get information about file '%s'",
-		 myGlobals.runningPref.protoSpecs);
+		 tmpStr);
       return;
     }
 
     bufferCurrent = buffer = (char*)malloc(buf.st_size+8) /* just to be safe */;
 
     traceEvent(CONST_TRACE_ALWAYSDISPLAY, "PROTO_INIT: Processing protocol file: '%s', size: %ld",
-	       myGlobals.runningPref.protoSpecs, (long)(buf.st_size+8));
+	       tmpStr, (long)(buf.st_size+8));
 
     for (;;) {
       bufferCurrent = fgets(bufferCurrent, buf.st_size, fd);
@@ -512,6 +517,11 @@
 	bufferWork[1] = '\0';
       }
 
+    bufferWork = strchr(bufferCurrent, '\r');
+      if(bufferWork != NULL) {
+	bufferWork[0] = ',';
+	bufferWork[1] = '\0';
+      }
       /* Move pointer to end-of-string for read of next line */
       bufferCurrent = strchr(bufferCurrent, '\0');
     }
@@ -546,8 +556,6 @@
 		   "PROTO_INIT: Unknown protocol '%s'. It has been ignored",
 		   proto);
       else {
-	char tmpStr[255];
-
 	protoName[0] = '\0';
 	memset(tmpStr, 0, sizeof(tmpStr));
 	strncpy(tmpStr, &protoName[1], sizeof(tmpStr));
@@ -1134,6 +1142,16 @@
 
   termGdbm();
   termDB();
+  
+  if(myGlobals.geo_ip_db != NULL) {
+    GeoIP_delete(myGlobals.geo_ip_db);
+    myGlobals.geo_ip_db = NULL;
+  }
+
+  if(myGlobals.geo_ip_asn_db != NULL) {
+    GeoIP_delete(myGlobals.geo_ip_asn_db);
+    myGlobals.geo_ip_asn_db = NULL;
+  }
 
   tryLockMutex(&myGlobals.gdbmMutex, "cleanup");
   deleteMutex(&myGlobals.gdbmMutex);
diff -uNr ntop-3.3.8/ntop.h ntop-3.3.9/ntop.h
--- ntop-3.3.8/ntop.h	2008-10-01 23:03:36.000000000 +0200
+++ ntop-3.3.9/ntop.h	2008-11-24 08:11:31.000000000 +0100
@@ -404,6 +404,19 @@
 
 #endif /* WIN32 */
 
+/* Undef below is a workaround for a silly memcpy definition */
+#ifdef BSD
+#undef BSD
+#define BSD_TEMP
+#endif
+
+#include "GeoIP.h"
+#include "GeoIPCity.h"
+
+#ifdef BSD_TEMP
+#define BSD
+#endif
+
 /*
  * Packet Capture Library by Lawrence Berkeley National Laboratory
  * Network Research Group
Dateien ntop-3.3.8/p2c.opt.table.gz und ntop-3.3.9/p2c.opt.table.gz sind verschieden.
diff -uNr ntop-3.3.8/pbuf.c ntop-3.3.9/pbuf.c
--- ntop-3.3.8/pbuf.c	2008-08-05 12:06:31.000000000 +0200
+++ ntop-3.3.9/pbuf.c	2008-12-09 12:41:47.000000000 +0100
@@ -3300,6 +3300,8 @@
 	  srcHost = lookupHost(NULL, ether_src, vlanId, 0, 0, actualDeviceId);
 	  dstHost = lookupHost(NULL, ether_dst, vlanId, 0, 0, actualDeviceId);
 
+	  if((srcHost == NULL) || (dstHost == NULL)) return;
+
 	  allocHostTrafficCounterMemory(srcHost, nonIPTraffic, sizeof(NonIPTraffic));
 	  allocHostTrafficCounterMemory(dstHost, nonIPTraffic, sizeof(NonIPTraffic));
 	  if((srcHost->nonIPTraffic == NULL) || (dstHost->nonIPTraffic == NULL)) return;
@@ -3351,7 +3353,8 @@
 
 		  switch(element.cdp_type) {
 		  case 0x0001: /* Device Id */
-		    if((srcHost->hostResolvedName[0] == '\0') || (strcmp(srcHost->hostResolvedName, srcHost->hostNumIpAddress))) {
+		    if((srcHost->hostResolvedName[0] == '\0') 
+		       || (strcmp(srcHost->hostResolvedName, srcHost->hostNumIpAddress))) {
 		      u_short tmpStrLen = min(element.cdp_len-4, MAX_LEN_SYM_HOST_NAME-1);
 		      strncpy(srcHost->hostResolvedName, (char*)&cdp[cdp_idx], tmpStrLen);
 		      srcHost->hostResolvedName[tmpStrLen] = '\0';
@@ -3596,7 +3599,8 @@
 		    if(strlen(nodeName) >= (MAX_LEN_SYM_HOST_NAME-1))
 		      nodeName[MAX_LEN_SYM_HOST_NAME-2] = '\0';
 
-		    if(srcHost->nonIPTraffic == NULL) srcHost->nonIPTraffic = (NonIPTraffic*)calloc(1, sizeof(NonIPTraffic));
+		    if(srcHost->nonIPTraffic == NULL) srcHost->nonIPTraffic = (NonIPTraffic*)calloc(1, 
+												    sizeof(NonIPTraffic));
 		    if(srcHost->nonIPTraffic == NULL) return;
 
 		    srcHost->nonIPTraffic->atNodeName = strdup(nodeName);
diff -uNr ntop-3.3.8/perl/test.pl ntop-3.3.9/perl/test.pl
--- ntop-3.3.8/perl/test.pl	2008-07-21 00:40:06.000000000 +0200
+++ ntop-3.3.9/perl/test.pl	2008-12-08 23:24:05.000000000 +0100
@@ -7,16 +7,44 @@
 
 send_http_header(1, "Known ntop hosts");
 
-# --------------------------------------------- 
+# ---------------------------------------------
 
-#loadHosts();
+loadHosts();
 
 #while ( my ($key, $value) = each(%hosts) ) {
 #    print "$key => $value\n";
 #}
 
-#foreach $key (sort(keys %hosts)) {
-#    print "[key=", $key,"][value=", $hosts{$key}"\n";
+#my @sorted_by_hostname      = sort { ${$a}{'ipAddress'}  cmp ${$b}{'ipAddress'} }  values %hosts;
+#my @traffic = sort keys %hosts;
+
+if(0) {
+print "################################################\n";
+
+foreach $key (sort(keys %hosts)) {
+    print "[key=", $key,"][ipAddress=",${$key}{'ipAddress'},"][macAddress=",${$key}{'macAddress'},"][pktSent/pktRcvd=",${$key}{'pktSent'},"/",${$key}{'pktRcvd'},"]\n";
+}
+
+print "################################################\n";
+
+getFirstHost(0);
+loadHost();
+while(($host{'ethAddress'} ne "") || ($host{'ipAddress'} ne ""))  {
+    print "+ [ipAddress=",$host{'ipAddress'},"][macAddress=",$host{'macAddress'},"][pktSent/pktRcvd=",$host{'pktSent'},"/",$host{'pktRcvd'},"]\n";
+    getNextHost(0);
+    loadHost();
+}
+}
+
+#for my $k1 ( sort keys %hosts ) {
+#    print "k1: $k1\n";
+#    for my $k2 ( keys %{$k1} ) {
+#	print "k2: $k2 $hosts{ $k1 }{ $k2 }\n";
+#    }
+#}
+
+#foreach $key (sort(keys %hosts{'a'})) {
+#    print $key,"\n";
 #}
 
 #exit
@@ -30,8 +58,7 @@
 sendString("<tr><th>MAC</th><th colspan=2>IP</th><th>Packets</th><th>Bytes</th></tr>\n");
 
 
-while(($host{'ethAddress'} ne "") 
-      || ($host{'ipAddress'} ne ""))  {
+while(($host{'ethAddress'} ne "") || ($host{'ipAddress'} ne ""))  {
     my $mac_addr;
 
     if($host{'ethAddress'} ne "") {
diff -uNr ntop-3.3.8/perl.c ntop-3.3.9/perl.c
--- ntop-3.3.8/perl.c	2008-08-16 11:32:35.000000000 +0200
+++ ntop-3.3.9/perl.c	2008-12-08 23:24:05.000000000 +0100
@@ -33,8 +33,8 @@
 
 PerlInterpreter *my_perl;  /***    The Perl interpreter    ***/
 
-static HostTraffic *perl_host = NULL;
-static HV * ss = NULL;
+static HostTraffic *ntop_host = NULL;
+static HV * perl_host = NULL;
 static HV * ss_hosts = NULL;
 
 /*
@@ -79,21 +79,21 @@
 
 /* *********************************************************** */
 
-#define PERL_STORE_STRING(s, a, b) hv_store(s, a, strlen(a), newSVpv(b, strlen(b)), 0);
-#define PERL_STORE_NUM(s, a, b)    { safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%u", b); PERL_STORE_STRING(s, a, buf); }
+#define PERL_STORE_STRING(x, a, b) hv_store(x, a, strlen(a), newSVpv(b, strlen(b)), 0);
+#define PERL_STORE_NUM(x, a, b)    { char buf[64]; safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "%u", b); PERL_STORE_STRING(x, a, buf); }
 
 static void ntop_perl_loadHost_values(HV * my_ss, HostTraffic *host) {
-  char buf[64];
+  traceEvent(CONST_TRACE_INFO, "[perl] loadHost_values()");
 
-  PERL_STORE_STRING(ss, "ethAddress", host->ethAddressString);
-  PERL_STORE_STRING(ss, "ipAddress", host->hostNumIpAddress);
-  PERL_STORE_STRING(ss, "hostResolvedName", host->hostResolvedName);
-  PERL_STORE_NUM(ss, "vlanId", host->vlanId);
-  PERL_STORE_NUM(ss, "hostAS", host->hostAS);
-  PERL_STORE_NUM(ss, "pktSent", host->pktSent.value);
-  PERL_STORE_NUM(ss, "pktRcvd", host->pktRcvd.value);
-  PERL_STORE_NUM(ss, "bytesSent", host->bytesSent.value);
-  PERL_STORE_NUM(ss, "bytesRcvd", host->bytesRcvd.value);
+  PERL_STORE_STRING(my_ss, "ethAddress", host->ethAddressString);
+  PERL_STORE_STRING(my_ss, "ipAddress", host->hostNumIpAddress);
+  PERL_STORE_STRING(my_ss, "hostResolvedName", host->hostResolvedName);
+  PERL_STORE_NUM(my_ss, "vlanId", host->vlanId);
+  PERL_STORE_NUM(my_ss, "hostAS", host->hostAS);
+  PERL_STORE_NUM(my_ss, "pktSent", host->pktSent.value);
+  PERL_STORE_NUM(my_ss, "pktRcvd", host->pktRcvd.value);
+  PERL_STORE_NUM(my_ss, "bytesSent", host->bytesSent.value);
+  PERL_STORE_NUM(my_ss, "bytesRcvd", host->bytesRcvd.value);
 }
 
 /* *********************************************************** */
@@ -101,16 +101,16 @@
 void ntop_perl_loadHost() {
   char buf[64];
 
-  traceEvent(CONST_TRACE_INFO, "[perl] loadHost()");
+  traceEvent(CONST_TRACE_INFO, "[perl] loadHost(%p)", ntop_host);
 
-  if(ss) {
-    hv_undef(ss);
-    ss = NULL;
+  if(perl_host) {
+    hv_undef(perl_host);
+    perl_host = NULL;
   }
 
-  if(perl_host) {
-    ss = perl_get_hv ("main::host", TRUE);
-    ntop_perl_loadHost_values(ss, perl_host);
+  if(ntop_host) {
+    perl_host = perl_get_hv ("main::host", TRUE);
+    ntop_perl_loadHost_values(perl_host, ntop_host);
   }
 }
 
@@ -121,7 +121,7 @@
   char buf[64];
   u_int actualDeviceId = 0;
 
-  traceEvent(CONST_TRACE_INFO, "[perl] loadHost()");
+  traceEvent(CONST_TRACE_INFO, "[perl] loadHosts()");
 
   if(ss_hosts) {
     hv_undef(ss_hosts);
@@ -130,18 +130,27 @@
 
   host = getFirstHost(actualDeviceId);
 
+  /*
+   * create a new variable, the %hosts hash
+   */
   ss_hosts = perl_get_hv ("main::hosts", TRUE);
 
   while(host != NULL) {
-    HV *elem;
+    static HV *elem;
     char *key = (host->ethAddressString[0] != '\0') ? host->ethAddressString : host->hostNumIpAddress;
-    
-    
-    elem = newHV();
+
+    snprintf(buf, sizeof(buf), "main::%s", key);
+    traceEvent(CONST_TRACE_INFO, "[perl] Adding perl hash '%s'", buf);
+    elem = perl_get_hv(buf, TRUE);
+
+    /*
+     * populate the %hosts hash
+     * key   = $key
+     * value = the reference to the newly created hash
+     */
+    hv_store(ss_hosts, key, strlen(key), newRV_inc ((SV *) elem), 0); 
     ntop_perl_loadHost_values(elem, host);
-    hv_store_ent( ss_hosts, newSVpv(key, strlen(key)), elem, 0 );
     traceEvent(CONST_TRACE_INFO, "[perl] Added %s", key);
-
     host = getNextHost(actualDeviceId, host);
   }
 }
@@ -150,22 +159,22 @@
 
 
 void ntop_perl_getFirstHost(int actualDeviceId) {
-  perl_host = getFirstHost(actualDeviceId);
+  ntop_host = getFirstHost(actualDeviceId);
 
   traceEvent(CONST_TRACE_INFO, "[perl] getFirstHost(%d)=%p",
-	     actualDeviceId, perl_host);
+	     actualDeviceId, ntop_host);
 }
 
 /* *********************************************************** */
 
 void ntop_perl_getNextHost(int actualDeviceId) {
-  if(perl_host == NULL) {
+  if(ntop_host == NULL) {
     ntop_perl_getFirstHost(actualDeviceId);
   } else {
-    perl_host = getNextHost(actualDeviceId, perl_host);
+    ntop_host = getNextHost(actualDeviceId, ntop_host);
   }
 
-  traceEvent(CONST_TRACE_INFO, "[perl] getNextHost()=%p", perl_host);
+  traceEvent(CONST_TRACE_INFO, "[perl] getNextHost()=%p", ntop_host);
 }
 
 /* *********************************************************** */
@@ -195,14 +204,33 @@
 /* http://localhost:3000/perl/test.pl */
 
 int handlePerlHTTPRequest(char *url) {
-  int perl_argc = 2;
+  int perl_argc = 2, idx, found = 0;
   char perl_path[256];
   char * perl_argv[] = { "", NULL };
+  struct stat statbuf;
 
   traceEvent(CONST_TRACE_WARNING, "Calling perl... [%s]", url);
 
+  for(idx=0; (!found) && (myGlobals.dataFileDirs[idx] != NULL); idx++) {
   safe_snprintf(__FILE__, __LINE__, perl_path, sizeof(perl_path), 
-	  "%s/perl/%s", myGlobals.spoolPath, url);
+	  "%s/perl/%s", myGlobals.dataFileDirs[idx], url);
+    revertSlashIfWIN32(perl_path, 0);
+
+    if(!stat(perl_path, &statbuf)) {
+      /* Found */
+      /* traceEvent(CONST_TRACE_INFO, "[perl] [%d] Found %s", idx, perl_path); */
+      found = 1;
+      break;
+    } else {
+      /* traceEvent(CONST_TRACE_INFO, "[perl] [%d] Not found %s", idx, perl_path); */
+    }
+  }
+
+  if(!found) {
+    returnHTTPpageNotFound(NULL);
+    return(1);
+  }
+
   perl_argv[1] = perl_path;
 
   PERL_SYS_INIT(&perl_argc, &perl_argv);
diff -uNr ntop-3.3.8/plugin.c ntop-3.3.9/plugin.c
--- ntop-3.3.8/plugin.c	2008-08-17 23:06:33.000000000 +0200
+++ ntop-3.3.9/plugin.c	2008-11-07 01:56:35.000000000 +0100
@@ -22,7 +22,7 @@
 
 #ifdef MAKE_STATIC_PLUGIN
 extern PluginInfo* icmpPluginEntryFctn(void);
-extern PluginInfo* sflowPluginEntryFctn(void)
+extern PluginInfo* sflowPluginEntryFctn(void);
 extern PluginInfo* rrdPluginEntryFctn(void);
 extern PluginInfo* cpacketPluginEntryFctn(void);
 extern PluginInfo* netflowPluginEntryFctn(void);
diff -uNr ntop-3.3.8/plugins/netflowPlugin.c ntop-3.3.9/plugins/netflowPlugin.c
--- ntop-3.3.8/plugins/netflowPlugin.c	2008-08-11 01:05:06.000000000 +0200
+++ ntop-3.3.9/plugins/netflowPlugin.c	2008-12-08 16:53:31.000000000 +0100
@@ -28,7 +28,7 @@
 static void* netflowUtilsLoop(void* _deviceId);
 #endif
 
-/* #define DEBUG_FLOWS */
+#define DEBUG_FLOWS
 
 #define CONST_NETFLOW_STATISTICS_HTML       "statistics.html"
 
@@ -134,7 +134,7 @@
     handleNetflowHTTPrequest,
     NULL, /* no host creation/deletion handle */
 #ifdef DEBUG_FLOWS
-    "udp and (port 2055 or port 1024)",
+    "udp and (port 2055 or port 1024 or port 20000)",
 #else
     NULL, /* no capture */
 #endif
@@ -3035,6 +3035,10 @@
 	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "Interface&nbsp;Name: %s<br>",
 		      ifStats->interface_name);
 	sendString(buf);
+      } else {
+	safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "Interface&nbsp;Id: %d<br>",
+		      ifStats->interface_id);
+	sendString(buf);
       }
 
       safe_snprintf(__FILE__, __LINE__, buf, sizeof(buf), "Pkts:&nbsp;%s&nbsp;in/%s&nbsp;out<br>",
@@ -3971,7 +3975,7 @@
   int sampledPacketSize;
   int deviceId, rc;
 
-  if(myGlobals.runningPref.rFileName != NULL) {
+  if(myGlobals.pcap_file_list != NULL) {
     /* ntop is reading packets from a file */
     struct ether_header ehdr;
     u_int caplen = h->caplen;
